## org.apache.lucene.search.join
Class BlockJoinCollector

    java.lang.Object
      org.apache.lucene.search.Collector
          org.apache.lucene.search.join.BlockJoinCollector

    public class BlockJoinCollector

extends org.apache.lucene.search.Collector

Collects parent document hits for a Query containing one more more BlockJoinQuery clauses, sorted by the specified parent Sort. Note that this cannot perform arbitrary joins; rather, it requires that all joined documents are indexed as a doc block (using `IndexWriter.addDocuments(java.util.Collection<org.apache.lucene.document.Document>)` or `IndexWriter.updateDocuments(org.apache.lucene.index.Term, java.util.Collection<org.apache.lucene.document.Document>)`). Ie, the join is computed at index time.

The parent Sort must only use fields from the parent documents; sorting by field in the child documents is not supported.

You should only use this collector if one or more of the clauses in the query is a `BlockJoinQuery`. This collector will find those query clauses and record the matching child documents for the top scoring parent documents.

Multiple joins (star join) and nested joins and a mix of the two are allowed, as long as in all cases the documents corresponding to a single row of each joined parent table were indexed as a doc block.

For the simple star join you can retrieve the `TopGroups` instance containing each `BlockJoinQuery`'s matching child documents for the top parent groups, using `getTopGroups(org.apache.lucene.search.join.BlockJoinQuery, org.apache.lucene.search.Sort, int, int, int, boolean)`. Ie, a single query, which will contain two or more `BlockJoinQuery`'s as clauses representing the star join, can then retrieve two or more `TopGroups` instances.

For nested joins, the query will run correctly (ie, match the right parent and child documents), however, because TopGroups is currently unable to support nesting (each group is not able to hold another TopGroups), you are only able to retrieve the TopGroups of the first join. The TopGroups of the nested joins will not be correct. See `org.apache.lucene.search.join` for a code sample.

WARNING: This API is experimental and might change in incompatible ways in the next release.

Constructor Summary
`BlockJoinCollector(org.apache.lucene.search.Sort sort, int numParentHits, boolean trackScores, boolean trackMaxScore)`

Method Summary
`boolean` `acceptsDocsOutOfOrder()`
`void` `collect(int parentDoc)`
`org.apache.lucene.search.grouping.TopGroups<Integer>` `getTopGroups(BlockJoinQuery query, org.apache.lucene.search.Sort withinGroupSort, int offset, int maxDocsPerGroup, int withinGroupOffset, boolean fillSortFields)` Return the TopGroups for the specified BlockJoinQuery.
`void` `setNextReader(org.apache.lucene.index.IndexReader reader, int docBase)`
`void` `setScorer(org.apache.lucene.search.Scorer scorer)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BlockJoinCollector

    public BlockJoinCollector(org.apache.lucene.search.Sort sort,
                              int numParentHits,
                              boolean trackScores,
                              boolean trackMaxScore)
                       throws IOException

Throws:
  `IOException`

Method Detail

### collect

    public void collect(int parentDoc)
                 throws IOException

  Specified by:
    `collect` in class `org.apache.lucene.search.Collector`
  Throws:
    `IOException`

### setNextReader

    public void setNextReader(org.apache.lucene.index.IndexReader reader,
                              int docBase)
                       throws IOException

  Specified by:
    `setNextReader` in class `org.apache.lucene.search.Collector`
  Throws:
    `IOException`

### acceptsDocsOutOfOrder

    public boolean acceptsDocsOutOfOrder()

  Specified by:
    `acceptsDocsOutOfOrder` in class `org.apache.lucene.search.Collector`

### setScorer

    public void setScorer(org.apache.lucene.search.Scorer scorer)

  Specified by:
    `setScorer` in class `org.apache.lucene.search.Collector`

### getTopGroups

    public org.apache.lucene.search.grouping.TopGroups<Integer> getTopGroups(BlockJoinQuery query,
                                                                             org.apache.lucene.search.Sort withinGroupSort,
                                                                             int offset,
                                                                             int maxDocsPerGroup,
                                                                             int withinGroupOffset,
                                                                             boolean fillSortFields)
                                                                      throws IOException

  Return the TopGroups for the specified BlockJoinQuery. The groupValue of each GroupDocs will be the parent docID for that group. Note that the `GroupDocs.totalHits`, which would be the total number of child documents matching that parent, is not computed (will always be 0). Returns null if no groups matched.

  Throws:
    `IOException`

Copyright © 2000-2011 Apache Software Foundation. All Rights Reserved.